/* 
4. Übung zu Workshop 'Papervision': Benutzung des Templates 
Laden von zwei DAE Models und Anwendung von zwei Shadern/Materials
Ergebnis: Ein Fenster in dem sich zwei Models mit Flatshader und Gouraudmaterial drehen
alle Erläuterungen/Kommentare wurden im Workshop erklärt!
*/
package  {

	import flash.display.Sprite;
	import flash.events.Event;
	
	import org.papervision3d.cameras.*;
	import org.papervision3d.objects.parsers.DAE;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.shadematerials.GouraudMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
    
    	
	public class Workshop_4 extends Sprite {
		
		private var viewport:Viewport3D;
		private var renderer:BasicRenderEngine;
		private var scene:Scene3D;
		private var camera:Camera3D;
		
		private var daeFlat:DAE;
		private var daePhong:DAE;
		private var flatShadeMaterial:FlatShadeMaterial;
		private var gouraudMaterial:GouraudMaterial;
		private var pointLight:PointLight3D;
		private var materialsListFlat:MaterialsList;
		private var materialsListGouraud:MaterialsList;
				
		
		public function Workshop_4(vpWidth:Number = 800, vpHeight:Number = 600):void {
			initPapervision(vpWidth, vpHeight);
			initEvents();
			init3d();
		}
		
		private function initPapervision(vpWidth:Number, vpHeight:Number):void {
			viewport = new Viewport3D(vpWidth, vpHeight);
			addChild(viewport);
			renderer = new BasicRenderEngine();
			scene = new Scene3D();
			camera = new Camera3D();
		
			pointLight = new PointLight3D(true);	
			pointLight.z = -1500;
			
			flatShadeMaterial = new FlatShadeMaterial(pointLight, 0xFFFFFF, 0x000000);
			gouraudMaterial = new GouraudMaterial(pointLight, 0xF9040F, 0x02F060);
						
			materialsListFlat = new MaterialsList();
			materialsListFlat.addMaterial(flatShadeMaterial, "material");
			materialsListGouraud = new MaterialsList();
			materialsListGouraud.addMaterial(gouraudMaterial, "material");		
		}
		
		
		private function init3d():void {
			daeFlat = new DAE();
			daeFlat.load("FlatShade.dae", materialsListFlat);
			daeFlat.scale = 200;
			scene.addChild(daeFlat);
			
			daePhong = new DAE();
			daePhong.load("PhongShade.dae", materialsListGouraud);
			daePhong.scale = 200;
			daePhong.moveLeft(600);
			scene.addChild(daePhong);
		}
		
		private function processFrame():void {
			daeFlat.yaw(2);
			daeFlat.roll(1);
			daePhong.yaw(2);
			daePhong.roll(1);
		}
		
		
		private function initEvents():void {
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		private function onEnterFrame( ThisEvent:Event ):void {
			processFrame(); 
			renderer.renderScene(scene, camera, viewport);
		}
	}
}